<template>
    <div>
        <v-card elevation="1" class="admin-content">
            <v-card-title>
                Liste des clients
                <v-divider class="ml-4 mr-2" inset vertical></v-divider>
                <v-col cols="12" md="4">
                    <v-text-field
                        v-model="search"
                        append-icon="mdi-magnify"
                        label="Rechercher un client"
                        single-line
                        hide-details
                    />
                </v-col>
                <v-divider class="ml-4 mr-6" inset vertical></v-divider>
                <v-btn
                    color="secondary"
                    @click="dialogNewCustomer = true"
                >
                    <v-icon left>
                        mdi-plus
                    </v-icon>
                    Ajouter
                </v-btn>
                <v-dialog
                    v-model="dialogNewCustomer"
                    max-width="500px"
                >
                    <v-card>
                        <v-card-title>
                            <span class="headline">Ajout d'un client</span>
                        </v-card-title>
                         <v-form
                            v-model="isFormValid"
                            ref="newCustomerForm"
                            @submit.prevent="submitNewCustomerForm"
                        >
                        <v-card-text>
                            <v-container>
                                <v-row>
                                    <v-col cols="12" sm="6">
                                        <v-select
                                            v-model="newCustomer.title"
                                            :items="titleSelectItems"
                                            label="Titre"
                                        ></v-select>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newCustomer.firstName"
                                            label="Nom"
                                            :rules="[$utils.rules.required]"
                                            :counter="32"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newCustomer.lastName"
                                            label="Prénom"
                                            :rules="[$utils.rules.required]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-select
                                            v-model="newCustomer.gender"
                                            :items="genderSelectItems"
                                            label="Gendre"
                                        ></v-select>
                                    </v-col>
                                    <v-col cols="12" sm="12">
                                        <v-text-field
                                            v-model="newCustomer.email"
                                            label="Adresse e-mail"
                                            :rules="[$utils.rules.required, $utils.rules.email]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newCustomer.dob"
                                            type="date"
                                            label="Date de naissance"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newCustomer.plainPassword"
                                            label="Mot de passe"
                                            type="password"
                                            :rules="[$utils.rules.required]"
                                            :counter="250"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newCustomer.phoneNumber"
                                            label="Numéro de téléphone"
                                            :rules="[$utils.rules.required]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                </v-row>
                            </v-container>
                        </v-card-text>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn
                                color="blue darken-1"
                                text
                                @click="dialogNewCustomer = false"
                            >
                                Annuler
                            </v-btn>
                            <v-btn
                                color="blue darken-1"
                                type="submit"
                                :disabled="!isFormValid"
                                text
                            >
                                Ajouter
                            </v-btn>
                        </v-card-actions>
                        </v-form>
                    </v-card>
                </v-dialog>
                <v-dialog v-model="dialogDelete" max-width="500px">
                    <v-card>
                        <v-card-title class="headline">Etes-vous sûr de vouloir supprimer ?</v-card-title>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue darken-1" text @click="closeDelete">Annuler</v-btn>
                            <v-btn color="blue darken-1" text @click="confirmDeleteCustomerDialog">OK</v-btn>
                            <v-spacer></v-spacer>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-card-title>
            <v-data-table
                :headers="customerTableHeaders"
                :items="getCustomers"
                :search="search"
                :items-per-page="10"
                :loading="loading"
                no-results-text="Aucun résultat n'a été trouvé pour votre recherche"	
                no-data-text="Il n'y a pas de données disponibles"	
                loading-text="Les données sont en cours de chargement"
            >
                <template v-slot:[`item.enabled`]="{item}">
                    <v-chip
                        :color="getEnabledColor(item.enabled)"
                        dark
                        class="font-weight-bold"
                    >
                        {{ item.enabled === 0 ? 'En attente' : 'Vérifié' }}
                    </v-chip>
                </template>
                <template v-slot:[`item.actions`]="{item}">
                    <v-icon
                        class="mr-2"
                        @click="editCustomer(item.id)"
                    >
                        mdi-pencil
                    </v-icon>
                </template>
            </v-data-table>
        </v-card>
        <v-snackbar
            v-model="customersSnackbar"
            :timeout="3000"
            :color="snackbarColor"
        >
            {{snackbarMessage}}
            <template v-slot:action="{ attrs }">
                <v-btn
                    color="white"
                    text
                    v-bind="attrs"
                    @click="customersSnackbar = false"
                >
                    Fermer
                </v-btn>
            </template>
        </v-snackbar>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';

export default {
    name: 'Customers',
    data: () => ({
        search: '',
        loading: false,
        dialogNewCustomer: false,
        dialogDelete: false,
        currentCustomerId: null,
        customersSnackbar: false,
        snackbarMessage: '',
        snackbarColor: '',
        isFormValid: true,
        newCustomer: {
            type: 'client',
            title: '',
            email: '',
            plainPassword: '',
            gender: '',
            firstName: '',
            lastName: '',
            dob: '',
            enabled: 0,
            phoneNumber: ''
        },
        titleSelectItems: ['Dr.', 'Me.'],
        genderSelectItems: [
            {text: 'Homme', value: 'men'},
            {text: 'Femme', value: 'women'},
            {text: 'Autre', value: 'other'}
        ],
    }),
    methods: {
        ...mapActions(['loadCustomers', 'deleteCustomer', 'addCustomer']),
        editCustomer(customerId) {
            this.$router.push({name: 'CustomerDetail', params: {customerId}})
        },
        deleteCustomerDialog(customerId) {
            this.dialogDelete = true
            this.currentCustomerId = customerId;
        },
        closeDelete() {
            this.dialogDelete = false;
            this.currentCustomerId = null;
        },
        confirmDeleteCustomerDialog() {
            this.deleteCustomer(this.currentCustomerId)
                .then(() => {
                    this.dialogDelete = false;
                    this.snackbarColor = 'green';
                    this.snackbarMessage = 'Le client a été supprimé avec succès';
                    this.customersSnackbar = true;
                })
                .catch(() => {
                    this.snackbarColor = 'red';
                    this.snackbarMessage = this.getCrudError;
                    this.customersSnackbar = true;
                });
        },
        submitNewCustomerForm() {
            this.addCustomer(this.newCustomer)
                .then(() => {
                    this.dialogNewCustomer = false;
                    this.snackbarColor = 'green';
                    this.snackbarMessage = 'Le nouveau client a été ajouté avec succès';
                    this.customersSnackbar = true;
                    this.$refs.newCustomerForm.reset();
                })
                .catch(() => {
                    this.snackbarColor = 'red';
                    this.snackbarMessage = this.getCrudError;
                    this.customersSnackbar = true;
                });
        },
        getEnabledColor(enabled) {
            if (enabled === 0) return 'orange'
            else return 'green';
        },
        loadingCustomers() {
            if (this.getCustomers === undefined || this.getCustomers.length === 0) {
                this.loading = true;
                this.loadCustomers()
                    .then(() => this.loading = false);
            }
            
        }
    },
    computed: {
        ...mapGetters(['getCustomers', 'getCrudError']),
        customerTableHeaders() {
            return [
                {text: 'Nom', align: 'start', value: 'firstName'},
                {text: 'Prénom', value: 'lastName'},
                {text: 'Statut', value: 'enabled'},
                {text: 'Téléphone', value: 'phoneNumber'},
                {text: 'Actions', value: 'actions', sortable: false},
            ]
        },
    },
    mounted() {
        this.loadingCustomers();
    }
}
</script>